/*
	Thread functions
	irs_ts_ws:  
		Read data of IRS, TS, and WS.
	encoder:
		Read counts of rotary encoder.
	uss_read:
		Read distance data mesuared by USS.
*/
#include <stdio.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <time.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <pthread.h>
#include "func_extern.h"
#include "control.h"
#include "irs_ts_ws.h"
#include "pwm_enc.h"
#include "uss.h"

void *irs_ts_ws(void *t)
{
        char *data_a;
        int i;

        while(1){

		irs_flag=0,ts_flag=0,ws_flag=0;

        	if ((fd4 = open("/dev/irs_ts_ws", O_RDONLY)) < 0) {
               		fprintf(stderr, "Error opening /dev/irs_ts_ws\n");
                	exit(0);
        	}

                data_a=irs;
                read(fd4,data_a,13);

                for(i=0;i<4;i++){
                        ts[i]=*data_a;
                        if(*data_a=='1') ts_flag=1;
                        data_a++;
                }

                for(i=0;i<4;i++){
                        irs[i]=*data_a;
                        if(*data_a=='1' && i >=2) irs_flag=1;
                        data_a++;
                }

                for(i=0;i<4;i++){
                        ws[i]=*data_a;
                        if(*data_a=='1') ws_flag=1;
                        data_a++;
		}


		close(fd4);
		usleep(50000);
        }
        pthread_exit(0);
}

void *encoder(void *t)
{

        fd_set rfds2;
        int retval1, retval2;
        struct timeval tv;

        tv.tv_sec=0;
        tv.tv_usec=20000;

        while(1){
                FD_ZERO(&rfds2);
                FD_SET(fd1, &rfds2);
                retval1 = select(FD_SETSIZE, &rfds2, NULL, NULL, &tv);
                if(retval1 > 0){
                        while(1){
                                count.br=0;
                                read(fd1, &count, sizeof(count));
                                retval2 = select(FD_SETSIZE, &rfds2, NULL, NULL, &tv);
                                if(retval2 == 0) break;
                        }
                        alw = - pi * (diameter) * count.left_sum / (cpr * gear);
                        arw = pi * (diameter) * count.right_sum / (cpr * gear);

                }
                usleep(100000);
                //usleep(40000);
        }
        pthread_exit(0);
}

void *uss_read(void *t)
{
        fd_set rfds;
        int retval,retval3=0;
        struct timeval tv;

        tv.tv_sec=0;
        //tv.tv_usec=50000;
        tv.tv_usec=20000;
        //tv.tv_usec=90000;

	while(1){

		retval=0;
		retval3=0;
	        FD_ZERO(&rfds);
       		FD_SET(fd0, &rfds);
        	retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
        	if (retval > 0) {
               		while(1){
                        	retval3=read(fd0, &uss_data, sizeof(uss_data));
                	}
        	}
		//if(retval3==-1) uss_data = 9999;
		usleep(10000);
	}
        pthread_exit(0);
}

void *uss_read2(void *t)
{
        fd_set rfds;
        int retval,retval3=0;
        struct timeval tv;

        tv.tv_sec=0;
        tv.tv_usec=50000;
        //tv.tv_usec=20000;
        //tv.tv_usec=90000;

	while(1){

		retval=0;
		retval3=0;
	        FD_ZERO(&rfds);
       		FD_SET(fd0, &rfds);
        	retval = select(FD_SETSIZE, &rfds, NULL, NULL, &tv);
        	if (retval > 0) {
			usleep(10000);
               		//while(1){
                        	retval3=read(fd0, &uss_data, sizeof(uss_data));
                	//}
			usleep(10000);
        	}
		else{
                                uss_data = 9999;
                                //break;
		}
		//if(retval3==-1) uss_data = 9999;
		usleep(10000);
	}

        pthread_exit(0);
}
