/*********************************************/
/*           LCD Test Program                */
/*                                           */
/*                  developed by Eri.Taguchi */
/*                     ver 1.0  Dec. 15 2000 */
/*********************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <sys/ioctl.h>
#include <string.h>
#include <unistd.h>

#include "lcd_nr.h"

static char *word2[]={"LCD test","MIRSATLM^LCD","^~100mm"};
static char *sel[]={"Select Number = "};
static char *sel2[]={"This number is not found.\nSelect Number Again = "};
static char *case2[]={"Cursor move Increment direction and Not display shift",
                      "Cursor move Increment direction and Display shift",
		      "Cursor move Decrement direction and Not display shift",
		      "Cursor move Decrement direction and Display shift"};
static char *case4[]={"0:<Cursor movement> and <Shift to the right>",
                      "1:<Cursor movement> and <Shift to the left>",
		      "2:<Character Shift> and <Shift to the right>",
		      "3:<Character Shift> and <Shift to the left>"};



int main(void){

  int fd,lcd[2];
  int wlen;
  int one,first,second;
  int d,c,b;
  int lcd_setcode=16;
  char buf[1],buf1[1],*buffer,word[35],meg[32]={};
  buffer = meg;
  
  lcd[0] = 1000;

  printf("\nLCD device driver Open.\n");
  printf("Start test of LCD!\n\n");

while(1){

  fd=open("/dev/lcd",O_RDWR);
  if(fd<0){
     fprintf(stderr,"Cannot Open LCD-Device-Driver.\n");
     return 1;
  }

  printf("Select LCD test number.\n");
  printf("   0:WRITE-method test   1:READ-method test \n");
  printf("   2:IOCTL-method test   3:End of LCD device driver test \n\n");

  printf("%s",sel[0]);
  scanf("%d",&one);
  printf("\n");

  switch(one){
     case 0 :
        do{
           printf("<<Start WRITE-method test>>\n\n");
	   printf("   Write LCD-module by ->\n");
	   printf("      0:yourself\n");
	   printf("      1:examples\n");
	   printf("      2:End of WRITE-method test\n");

           printf("%s",sel[0]);
           scanf("%d",&first);
           printf("\n");

           switch(first){
              case 0 :
		 printf("Write words =");
                 scanf("%s",word);
                 printf("\n");
		 wlen = strlen(word);
		 write(fd,word,wlen);
		 printf("Write words are <%s>.\n\n",word);
		 break;
	      case 1 :
		 printf("[examples]\n");
		 printf("   0:LCD test(1line)\n");
		 printf("   1:MIRSATLM(1line)\n");
		 printf("     LCD(2line)\n");
		 printf("   2:->100mm(2line)\n\n");

		 printf("%s",sel[0]);
		 scanf("%d",&second);
		 printf("\n");

		 switch(second){
		    case 0 :
		       write(fd,word2[0],8);
		       printf("Write words are [LCD test].\n");
		       break;
		    case 1 :
		       write(fd,word2[1],12);
		       printf("Write words are [MIRSATLM LCD].\n");
		       break;
		    case 2 :
                       write(fd,word2[2],7);
		       printf("Write words are [->100mm].\n");
		       break;
		    default :
		       printf("This number is not found.\n");
	               break;

		 }
		 break;

	      case 2 :
		 goto writeend;

	      default :
		 printf("This number is not found.\n");
		 break;

	   }
           printf("WRITE-method test again?[y/n]=");
           scanf("%s",buf1);
           printf("\n\n");
	}while(buf1[0] != 'n');
	writeend: ;
        break;

     case 1 :
        printf("<<Start READ-method test>>\n\n");
	printf("This test performs after the Write-method test.\n");
	read(fd,buffer,32);
	printf("   LCD-module shows <%s> now.\n\n",buffer);
	break;

     case 2 : 
        do{
           printf("<<Start IOCTL-method test>>\n");
           printf("   0:LCD_CLEAR                  1:LCD_ADD_ZERO \n");
           printf("   2:LCD_CURSOR_SHIFT           3:LCD_ON_OFF \n");
           printf("   4:LCD_LIST_OR_CURSOR         5:LCD_TWO_SET \n");
           printf("   6:LCD_ADD_SET                7:LCD_BF_ADD \n");
           printf("   8:End of IOCTL-method test \n\n");

           printf("%s",sel[0]);
           scanf("%d",&first);
           printf("\n");

           switch(first){
              case 0 :
	         printf("LCD_CLEAR was selected.\n\n\n");
                 ioctl(fd,LCD_CLEAR);
                 break;

              case 1 :
	         printf("LCD_ADD_ZERO was selected.\n\n\n");
	         ioctl(fd,LCD_ADD_ZERO);
	         break;

              case 2 :
	         printf("LCD_CURSOR_SHIFT was selected.\n");
	         printf("   0:%s\n",case2[0]);
	         printf("   1:%s\n",case2[1]);
	         printf("   2:%s\n",case2[2]);
	         printf("   3:%s\n\n",case2[3]);

                 printf("%s",sel[0]);
                 scanf("%d",&second);
                 printf("\n");

	         while (lcd[0] == 1000){
                    switch (second){
                       case 0  : lcd[0] = 1; lcd[1] = 0; 
				 printf("Set mode : %s\n\n",case2[0]);
				 break;
                       case 1  : lcd[0] = 1; lcd[1] = 1;
				 printf("Set mode : %s\n\n",case2[1]);
				 break;
                       case 2  : lcd[0] = 0; lcd[1] = 0;
				 printf("Set mode : %s\n\n",case2[2]);
				 break;
                       case 3  : lcd[0] = 0; lcd[1] = 1;
				 printf("Set mode : %s\n\n",case2[3]);
				 break;
                       default : lcd[0] = -1; break;
                    }
                    if(lcd[0] == -1){
	            printf("%s",sel2[0]);
                    scanf("%d",&second);
                    printf("\n");
	            lcd[0] = 1000;
                    }
                 }
                 ioctl(fd,LCD_CURSOR_SHIFT,lcd);
/*	         printf("lcd[0] = %x lcd[1] = %x\n",lcd[0],lcd[1]); */
	         lcd[0]=1000;
	         break;

              case 3 :
	         printf("LCD_ON_OFF was selected.\n");
	         printf("   Display ;   1:ON   0:OFF\n");
	         printf("   Cursor  ;   1:ON   0:OFF\n");
	         printf("   Blink   ;   1:ON   0:OFF\n\n");

                 printf("Select Number example= 0,0,0\n\n");
                 printf("%s",sel[0]);
	         scanf("%d,%d,%d",&d,&c,&b);
                 printf("\n");
	         lcd[0] = 0x04*d + 0x02*c + b;

	         ioctl(fd,LCD_ON_OFF,lcd);
	         printf("Display number is %d, and Cursor number is %d, and Blink number is %d.\n\n",d,c,b);
/*	         printf("lcd[0] = %x\n",lcd[0]); */
	         lcd[0]=1000;
	         break;

              case 4 :
	         printf("LCD_LIST_OR_CURSOR was selected.\n");
	         printf("   %s\n",case4[0]);
	         printf("   %s\n",case4[1]);
	         printf("   %s\n",case4[2]);
	         printf("   %s\n\n",case4[3]);

                 printf("%s",sel[0]);
                 scanf("%d",&second);
                 printf("\n");

	         while (lcd[0] == 1000){
                    switch (second){
                       case 0  : lcd[0] = 0; lcd[1] = 1; 
  				 printf("Select %s\n\n",case4[0]);
				 break;
                       case 1  : lcd[0] = 0; lcd[1] = 0; 
				 printf("Select %s\n\n",case4[1]);
				 break;
                       case 2  : lcd[0] = 1; lcd[1] = 1; 
				 printf("Select %s\n\n",case4[2]);
				 break;
                       case 3  : lcd[0] = 1; lcd[1] = 0; 
				 printf("Select %s\n\n",case4[3]);
				 break;
                       default : lcd[0] = -1; break;
                    }
                    if (lcd[0] == -1){
	               printf("%s",sel2[0]);
                       scanf("%d",&second);
                       printf("\n");
	               lcd[0] = 1000;
                    }
                 }
	         ioctl(fd,LCD_LIST_OR_CURSOR,lcd);
	         lcd[0]=1000;
	         break;

              case 5 :
	         printf("LCD_TWO_SET was selected.\n\n\n");
	         ioctl(fd,LCD_TWO_SET);
	         break;

              case 6 :
	         printf("LCD_ADD_SET was selected.\n\n");
	         printf("Address of LCD =");
	         scanf("%x",&second);
	         lcd[0] = second;
	         printf("\nSet Address = %d\n",lcd[0]);
	         ioctl(fd,LCD_ADD_SET,lcd);
	         lcd[0] =1000;
	         break;

              case 7 :
	         printf("LCD_BF_ADD was selected.\n\n");
	         ioctl(fd,LCD_BF_ADD,lcd);
	         if(*lcd >= CODE1){
	            printf("Internal operation of LCD is being performed.\n\n");
	            break;
                 }
	         printf("Instruction acceptable and Address is %x.\n\n",*lcd);
	         break;

	      case 8 :
	         goto ioctlend;

/*            case 9 :
	         ioctl(fd,LCD_HARDRESET);
	         break;
*/
              default :
		 printf("This number is not found.\n");
	         break;
           }
           printf("IOCTL-method test again?[y/n]=");
           scanf("%s",buf);
           printf("\n\n");
        }while(buf[0] != 'n');
        ioctlend: ;
        break;

     case 3:
	goto lcdend;

     default :
	printf("This number is not found.\n\n");
        break;

  }
  close(fd);
}
  lcdend:printf("LCD device driver test end. Good bye!!\n\n");
  close(fd);
  return 0;
}
